org.mariadb.jdbc

## Class AbstractMariaDbPrepareStatement

- java.lang.Object
- - org.mariadb.jdbc.MariaDbStatement
  - - org.mariadb.jdbc.AbstractMariaDbPrepareStatement

All Implemented Interfaces:
  AutoCloseable, Cloneable, PreparedStatement, Statement, Wrapper

Direct Known Subclasses:
  MariaDbClientPreparedStatement, MariaDbServerPreparedStatement

    public abstract class AbstractMariaDbPrepareStatement
    extends MariaDbStatement
    implements PreparedStatement, Cloneable

### Field Summary

Fields
`protected boolean` `useFractionalSeconds`

### Fields inherited from class org.mariadb.jdbc.MariaDbStatement

`batchResultSet, closed, connection, executionResult, lock, maxRows, protocol, queryTimeout, resultSetScrollType, rewriteOffset, timerTaskFuture`

### Fields inherited from interface java.sql.Statement

`CLOSE_ALL_RESULTS, CLOSE_CURRENT_RESULT, EXECUTE_FAILED, KEEP_CURRENT_RESULT, NO_GENERATED_KEYS, RETURN_GENERATED_KEYS, SUCCESS_NO_INFO`

### Constructor Summary

Constructors
Constructor and Description
`AbstractMariaDbPrepareStatement(MariaDbConnection connection, int resultSetScrollType)`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods Deprecated Methods
`protected abstract Calendar` `cal()`
`AbstractMariaDbPrepareStatement` `clone()` Clone statement.
`abstract ParameterMetaData` `getParameterMetaData()` Retrieves the number, types and properties of this `PreparedStatement` object's parameters.
`protected abstract boolean` `isNoBackslashEscapes()`
`void` `setArray(int parameterIndex, Array array)` Sets the designated parameter to the given `java.sql.Array` object.
`void` `setAsciiStream(int parameterIndex, InputStream stream)` This function reads up the entire stream and stores it in memory since we need to know the length when sending it to the server use the corresponding method with a length parameter if memory is an issue Sets the designated parameter to the given input stream.
`void` `setAsciiStream(int parameterIndex, InputStream stream, int length)` Sets the designated parameter to the given input stream, which will have the specified number of bytes.
`void` `setAsciiStream(int parameterIndex, InputStream stream, long length)` Sets the designated parameter to the given input stream, which will have the specified number of bytes.
`void` `setBigDecimal(int parameterIndex, BigDecimal bigDecimal)` Sets the designated parameter to the given `java.math.BigDecimal` value.
`void` `setBinaryStream(int parameterIndex, InputStream stream)` This function reads up the entire stream and stores it in memory since we need to know the length when sending it to the server Sets the designated parameter to the given input stream.
`void` `setBinaryStream(int parameterIndex, InputStream stream, int length)` Sets the designated parameter to the given input stream, which will have the specified number of bytes.
`void` `setBinaryStream(int parameterIndex, InputStream stream, long length)` Sets the designated parameter to the given input stream, which will have the specified number of bytes.
`void` `setBlob(int parameterIndex, Blob blob)` Sets the designated parameter to the given `java.sql.Blob` object.
`void` `setBlob(int parameterIndex, InputStream inputStream)` Sets the designated parameter to a `InputStream` object.
`void` `setBlob(int parameterIndex, InputStream inputStream, long length)` Sets the designated parameter to a `InputStream` object.
`void` `setBoolean(int parameterIndex, boolean value)` Sets the designated parameter to the given Java `boolean` value.
`void` `setByte(int parameterIndex, byte bit)` Sets the designated parameter to the given Java `byte` value.
`void` `setBytes(int parameterIndex, byte[] bytes)` Sets the designated parameter to the given Java array of bytes.
`void` `setCharacterStream(int parameterIndex, Reader reader)` Sets the designated parameter to the given `Reader` object.
`void` `setCharacterStream(int parameterIndex, Reader reader, int length)` Sets the designated parameter to the given `Reader` object, which is the given number of characters long.
`void` `setCharacterStream(int parameterIndex, Reader reader, long length)` Sets the designated parameter to the given `Reader` object, which is the given number of characters long.
`void` `setClob(int parameterIndex, Clob clob)` Sets the designated parameter to the given `java.sql.Clob` object.
`void` `setClob(int parameterIndex, Reader reader)` Sets the designated parameter to a `Reader` object.
`void` `setClob(int parameterIndex, Reader reader, long length)` Sets the designated parameter to a `Reader` object.
`void` `setDate(int parameterIndex, Date date)` Sets the designated parameter to the given `java.sql.Date` value using the default time zone of the virtual machine that is running the application.
`void` `setDate(int parameterIndex, Date date, Calendar cal)` Sets the designated parameter to the given `java.sql.Date` value, using the given `Calendar` object.
`void` `setDouble(int parameterIndex, double value)` Sets the designated parameter to the given Java `double` value.
`void` `setFloat(int parameterIndex, float value)` Sets the designated parameter to the given Java `float` value.
`void` `setInt(int column, int value)`
`void` `setLong(int parameterIndex, long value)` Sets the designated parameter to the given Java `long` value.
`void` `setNCharacterStream(int parameterIndex, Reader value)` Sets the designated parameter to a `Reader` object.
`void` `setNCharacterStream(int parameterIndex, Reader value, long length)` Sets the designated parameter to a `Reader` object.
`void` `setNClob(int parameterIndex, NClob value)` Sets the designated parameter to a `java.sql.NClob` object.
`void` `setNClob(int parameterIndex, Reader reader)` Sets the designated parameter to a `Reader` object.
`void` `setNClob(int parameterIndex, Reader reader, long length)` Sets the designated parameter to a `Reader` object.
`void` `setNString(int parameterIndex, String value)` Sets the designated paramter to the given `String` object.
`void` `setNull(int parameterIndex, int sqlType)` Sets the designated parameter to SQL `NULL`.
`void` `setNull(int parameterIndex, int sqlType, String typeName)` Sets the designated parameter to SQL `NULL`.
`void` `setNull(int parameterIndex, MariaDbType mysqlType)` Sets the designated parameter to SQL `NULL`.
`void` `setObject(int parameterIndex, Object obj)` Sets the value of the designated parameter using the given object.
`void` `setObject(int parameterIndex, Object obj, int targetSqlType)` Sets the value of the designated parameter with the given object.
`void` `setObject(int parameterIndex, Object obj, int targetSqlType, int scaleOrLength)` Sets the value of the designated parameter with the given object.
`protected abstract void` `setParameter(int parameterIndex, ParameterHolder holder)`
`void` `setRef(int parameterIndex, Ref ref)` Sets the designated parameter to the given `REF(<structured-type>)` value.
`void` `setRowId(int parameterIndex, RowId rowid)` Sets the designated parameter to the given `java.sql.RowId` object.
`void` `setShort(int parameterIndex, short value)` Sets the designated parameter to the given Java `short` value.
`void` `setSQLXML(int parameterIndex, SQLXML xmlObject)` Sets the designated parameter to the given `java.sql.SQLXML` object.
`void` `setString(int parameterIndex, String str)` Set string parameter.
`void` `setTime(int parameterIndex, Time time)`
`void` `setTime(int parameterIndex, Time time, Calendar cal)` Sets the designated parameter to the given `java.sql.Time` value, using the given `Calendar` object.
`void` `setTimestamp(int parameterIndex, Timestamp timestamp)` Sets the designated parameter to the given `java.sql.Timestamp` value.
`void` `setTimestamp(int parameterIndex, Timestamp timestamp, Calendar cal)` Sets the designated parameter to the given `java.sql.Timestamp` value, using the given `Calendar` object.
`void` `setUnicodeStream(int parameterIndex, InputStream x, int length)` Deprecated.
`void` `setURL(int parameterIndex, URL url)` Sets the designated parameter to the given `java.net.URL` value.
`protected abstract boolean` `useFractionalSeconds()`

### Methods inherited from class org.mariadb.jdbc.MariaDbStatement

`addBatch, cacheMoreResults, cancel, checkClose, clearBatch, clearWarnings, close, closeOnCompletion, execute, execute, execute, execute, executeBatch, executeInternal, executeQuery, executeQueryEpilog, executeQueryProlog, executeUpdate, executeUpdate, executeUpdate, executeUpdate, getConnection, getFetchDirection, getFetchSize, getGeneratedKeys, getMaxFieldSize, getMaxRows, getMoreResults, getMoreResults, getProtocol, getQueryTimeout, getResultSet, getResultSetConcurrency, getResultSetHoldability, getResultSetType, getUpdateCount, getWarnings, isClosed, isCloseOnCompletion, isPoolable, isWrapperFor, retrieveCallableResult, setCursorName, setEscapeProcessing, setFetchDirection, setFetchSize, setLocalInfileInputStream, setMaxFieldSize, setMaxRows, setPoolable, setQueryTimeout, setTimerTask, skipMoreResults, stopTimeoutTask, unloadDriver, unwrap`

### Methods inherited from class java.lang.Object

`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface java.sql.PreparedStatement

`addBatch, clearParameters, execute, executeLargeUpdate, executeQuery, executeUpdate, getMetaData, setObject, setObject`

### Methods inherited from interface java.sql.Statement

`addBatch, cancel, clearBatch, clearWarnings, close, closeOnCompletion, execute, execute, execute, execute, executeBatch, executeLargeBatch, executeLargeUpdate, executeLargeUpdate, executeLargeUpdate, executeLargeUpdate, executeQuery, executeUpdate, executeUpdate, executeUpdate, executeUpdate, getConnection, getFetchDirection, getFetchSize, getGeneratedKeys, getLargeMaxRows, getLargeUpdateCount, getMaxFieldSize, getMaxRows, getMoreResults, getMoreResults, getQueryTimeout, getResultSet, getResultSetConcurrency, getResultSetHoldability, getResultSetType, getUpdateCount, getWarnings, isClosed, isCloseOnCompletion, isPoolable, setCursorName, setEscapeProcessing, setFetchDirection, setFetchSize, setLargeMaxRows, setMaxFieldSize, setMaxRows, setPoolable, setQueryTimeout`

### Methods inherited from interface java.sql.Wrapper

`isWrapperFor, unwrap`

### Field Detail

#### useFractionalSeconds

    protected boolean useFractionalSeconds

### Constructor Detail

#### AbstractMariaDbPrepareStatement

    public AbstractMariaDbPrepareStatement(MariaDbConnection connection,
                                           int resultSetScrollType)

### Method Detail

#### isNoBackslashEscapes

    protected abstract boolean isNoBackslashEscapes()

#### useFractionalSeconds

    protected abstract boolean useFractionalSeconds()

#### cal

    protected abstract Calendar cal()

#### clone

    public AbstractMariaDbPrepareStatement clone()
                                          throws CloneNotSupportedException

Description copied from class: `MariaDbStatement`
Clone statement.

Overrides:
  `clone` in class `MariaDbStatement`
Returns:
  Clone statement.
Throws:
  `CloneNotSupportedException` - if any error occur.

#### setCharacterStream

    public void setCharacterStream(int parameterIndex,
                                   Reader reader,
                                   int length)
                            throws SQLException

Sets the designated parameter to the given `Reader` object, which is the given number of characters long. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Specified by:
  `setCharacterStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `reader` - the `java.io.Reader` object that contains the Unicode data
  `length` - the number of characters in the stream
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

#### setCharacterStream

    public void setCharacterStream(int parameterIndex,
                                   Reader reader,
                                   long length)
                            throws SQLException

Sets the designated parameter to the given `Reader` object, which is the given number of characters long. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Specified by:
  `setCharacterStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `reader` - the `java.io.Reader` object that contains the Unicode data
  `length` - the number of characters in the stream
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

#### setCharacterStream

    public void setCharacterStream(int parameterIndex,
                                   Reader reader)
                            throws SQLException

Sets the designated parameter to the given `Reader` object. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setCharacterStream` which takes a length parameter.

Specified by:
  `setCharacterStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `reader` - the `java.io.Reader` object that contains the Unicode data
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### setRef

    public void setRef(int parameterIndex,
                       Ref ref)
                throws SQLException

Sets the designated parameter to the given `REF(<structured-type>)` value. The driver converts this to an SQL `REF` value when it sends it to the database.

Specified by:
  `setRef` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `ref` - an SQL `REF` value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### setBlob

    public void setBlob(int parameterIndex,
                        Blob blob)
                 throws SQLException

Sets the designated parameter to the given `java.sql.Blob` object. The driver converts this to an SQL `BLOB` value when it sends it to the database.

Specified by:
  `setBlob` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `blob` - a `Blob` object that maps an SQL `BLOB` value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### setBlob

    public void setBlob(int parameterIndex,
                        InputStream inputStream,
                        long length)
                 throws SQLException

Sets the designated parameter to a `InputStream` object. The inputstream must contain the number of characters specified by length otherwise a `SQLException` will be generated when the `PreparedStatement` is executed. This method differs from the `setBinaryStream (int, InputStream, int)` method because it informs the driver that the parameter value should be sent to the server as a `BLOB`. When the `setBinaryStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGVARBINARY` or a `BLOB`

Specified by:
  `setBlob` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - index of the first parameter is 1, the second is 2, ...
  `inputStream` - An object that contains the data to set the parameter value to.
  `length` - the number of bytes in the parameter data.
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs; this method is called on a closed `PreparedStatement`; if the length specified is less than zero or if the number of bytes in the inputstream does not match the specfied length.
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### setBlob

    public void setBlob(int parameterIndex,
                        InputStream inputStream)
                 throws SQLException

Sets the designated parameter to a `InputStream` object. This method differs from the `setBinaryStream (int, InputStream)` method because it informs the driver that the parameter value should be sent to the server as a `BLOB`. When the `setBinaryStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGVARBINARY` or a `BLOB`

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setBlob` which takes a length parameter.

Specified by:
  `setBlob` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - index of the first parameter is 1, the second is 2, ...
  `inputStream` - An object that contains the data to set the parameter value to.
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs; this method is called on a closed `PreparedStatement` or if parameterIndex does not correspond to a parameter marker in the SQL statement,
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### setClob

    public void setClob(int parameterIndex,
                        Clob clob)
                 throws SQLException

Sets the designated parameter to the given `java.sql.Clob` object. The driver converts this to an SQL `CLOB` value when it sends it to the database.

Specified by:
  `setClob` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `clob` - a `Clob` object that maps an SQL `CLOB` value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### setClob

    public void setClob(int parameterIndex,
                        Reader reader,
                        long length)
                 throws SQLException

Sets the designated parameter to a `Reader` object. The reader must contain the number of characters specified by length otherwise a `SQLException` will be generated when the `PreparedStatement` is executed. This method differs from the `setCharacterStream (int, Reader, int)` method because it informs the driver that the parameter value should be sent to the server as a `CLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGVARCHAR` or a `CLOB`

Specified by:
  `setClob` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - index of the first parameter is 1, the second is 2, ...
  `reader` - An object that contains the data to set the parameter value to.
  `length` - the number of characters in the parameter data.
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs; this method is called on a closed `PreparedStatement` or if the length specified is less than zero.
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### setClob

    public void setClob(int parameterIndex,
                        Reader reader)
                 throws SQLException

Sets the designated parameter to a `Reader` object. This method differs from the `setCharacterStream (int, Reader)` method because it informs the driver that the parameter value should be sent to the server as a `CLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGVARCHAR` or a `CLOB`

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setClob` which takes a length parameter.

Specified by:
  `setClob` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - index of the first parameter is 1, the second is 2, ...
  `reader` - An object that contains the data to set the parameter value to.
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs; this method is called on a closed `PreparedStatement`or if parameterIndex does not correspond to a parameter marker in the SQL statement
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### setArray

    public void setArray(int parameterIndex,
                         Array array)
                  throws SQLException

Sets the designated parameter to the given `java.sql.Array` object. The driver converts this to an SQL `ARRAY` value when it sends it to the database.

Specified by:
  `setArray` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `array` - an `Array` object that maps an SQL `ARRAY` value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### setDate

    public void setDate(int parameterIndex,
                        Date date,
                        Calendar cal)
                 throws SQLException

Sets the designated parameter to the given `java.sql.Date` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `DATE` value, which the driver then sends to the database. With a `Calendar` object, the driver can calculate the date taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

Specified by:
  `setDate` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `date` - the parameter value
  `cal` - the `Calendar` object the driver will use to construct the date
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

#### setDate

    public void setDate(int parameterIndex,
                        Date date)
                 throws SQLException

Sets the designated parameter to the given `java.sql.Date` value using the default time zone of the virtual machine that is running the application. The driver converts this to an SQL `DATE` value when it sends it to the database.

Specified by:
  `setDate` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `date` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

#### setTime

    public void setTime(int parameterIndex,
                        Time time,
                        Calendar cal)
                 throws SQLException

Sets the designated parameter to the given `java.sql.Time` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `TIME` value, which the driver then sends to the database. With a `Calendar` object, the driver can calculate the time taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

Specified by:
  `setTime` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `time` - the parameter value
  `cal` - the `Calendar` object the driver will use to construct the time
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

#### setTime

    public void setTime(int parameterIndex,
                        Time time)
                 throws SQLException

Specified by:
  `setTime` in interface `PreparedStatement`
Throws:
  `SQLException`

#### setTimestamp

    public void setTimestamp(int parameterIndex,
                             Timestamp timestamp,
                             Calendar cal)
                      throws SQLException

Sets the designated parameter to the given `java.sql.Timestamp` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `TIMESTAMP` value, which the driver then sends to the database. With a `Calendar` object, the driver can calculate the timestamp taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

Specified by:
  `setTimestamp` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `timestamp` - the parameter value
  `cal` - the `Calendar` object the driver will use to construct the timestamp
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

#### setTimestamp

    public void setTimestamp(int parameterIndex,
                             Timestamp timestamp)
                      throws SQLException

Sets the designated parameter to the given `java.sql.Timestamp` value. The driver converts this to an SQL `TIMESTAMP` value when it sends it to the database.

Specified by:
  `setTimestamp` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `timestamp` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

#### setNull

    public void setNull(int parameterIndex,
                        int sqlType)
                 throws SQLException

Sets the designated parameter to SQL `NULL`.

Note: You must specify the parameter's SQL type.

Specified by:
  `setNull` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `sqlType` - the SQL type code defined in `java.sql.Types`
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if `sqlType` is a `ARRAY`, `BLOB`, `CLOB`, `DATALINK`, `JAVA_OBJECT`, `NCHAR`, `NCLOB`, `NVARCHAR`, `LONGNVARCHAR`, `REF`, `ROWID`, `SQLXML` or `STRUCT` data type and the JDBC driver does not support this data type

#### setNull

    public void setNull(int parameterIndex,
                        MariaDbType mysqlType)
                 throws SQLException

Sets the designated parameter to SQL `NULL`.

Note: You must specify the parameter's SQL type.

Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `mysqlType` - the type code defined in `MariaDbType`
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if `sqlType` is a `ARRAY`, `BLOB`, `CLOB`, `DATALINK`, `JAVA_OBJECT`, `NCHAR`, `NCLOB`, `NVARCHAR`, `LONGNVARCHAR`, `REF`, `ROWID`, `SQLXML` or `STRUCT` data type and the JDBC driver does not support this data type

#### setNull

    public void setNull(int parameterIndex,
                        int sqlType,
                        String typeName)
                 throws SQLException

Sets the designated parameter to SQL `NULL`. This version of the method `setNull` should be used for user-defined types and REF type parameters. Examples of user-defined types include: STRUCT, DISTINCT, JAVA_OBJECT, and named array types.

Note: To be portable, applications must give the SQL type code and the fully-qualified SQL type name when specifying a NULL user-defined or REF parameter. In the case of a user-defined type the name is the type name of the parameter itself. For a REF parameter, the name is the type name of the referenced type. If a JDBC driver does not need the type code or type name information, it may ignore it.
Although it is intended for user-defined and Ref parameters, this method may be used to set a null parameter of any JDBC type. If the parameter does not have a user-defined or REF type, the given typeName is ignored.

Specified by:
  `setNull` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `sqlType` - a value from `java.sql.Types`
  `typeName` - the fully-qualified name of an SQL user-defined type; ignored if the parameter is not a user-defined type or REF
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if `sqlType` is a `ARRAY`, `BLOB`, `CLOB`, `DATALINK`, `JAVA_OBJECT`, `NCHAR`, `NCLOB`, `NVARCHAR`, `LONGNVARCHAR`, `REF`, `ROWID`, `SQLXML` or `STRUCT` data type and the JDBC driver does not support this data type or if the JDBC driver does not support this method
Since:
  1.2

#### setParameter

    protected abstract void setParameter(int parameterIndex,
                                         ParameterHolder holder)
                                  throws SQLException

Throws:
  `SQLException`

#### setURL

    public void setURL(int parameterIndex,
                       URL url)
                throws SQLException

Sets the designated parameter to the given `java.net.URL` value. The driver converts this to an SQL `DATALINK` value when it sends it to the database.

Specified by:
  `setURL` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `url` - the `java.net.URL` object to be set
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### getParameterMetaData

    public abstract ParameterMetaData getParameterMetaData()
                                                    throws SQLException

Retrieves the number, types and properties of this `PreparedStatement` object's parameters.

Specified by:
  `getParameterMetaData` in interface `PreparedStatement`
Returns:
  a `ParameterMetaData` object that contains information about the number, types and properties for each parameter marker of this `PreparedStatement` object
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `PreparedStatement`
See Also:
  `ParameterMetaData`

#### setRowId

    public void setRowId(int parameterIndex,
                         RowId rowid)
                  throws SQLException

Sets the designated parameter to the given `java.sql.RowId` object. The driver converts this to a SQL `ROWID` value when it sends it to the database

Specified by:
  `setRowId` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `rowid` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### setNString

    public void setNString(int parameterIndex,
                           String value)
                    throws SQLException

Sets the designated paramter to the given `String` object. The driver converts this to a SQL `NCHAR` or `NVARCHAR` or `LONGNVARCHAR` value (depending on the argument's size relative to the driver's limits on `NVARCHAR` values) when it sends it to the database.

Specified by:
  `setNString` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - of the first parameter is 1, the second is 2, ...
  `value` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs; or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setNCharacterStream

    public void setNCharacterStream(int parameterIndex,
                                    Reader value,
                                    long length)
                             throws SQLException

Sets the designated parameter to a `Reader` object. The `Reader` reads the data till end-of-file is reached. The driver does the necessary conversion from Java character format to the national character set in the database.

Specified by:
  `setNCharacterStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - of the first parameter is 1, the second is 2, ...
  `value` - the parameter value
  `length` - the number of characters in the parameter data.
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs; or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### setNCharacterStream

    public void setNCharacterStream(int parameterIndex,
                                    Reader value)
                             throws SQLException

Sets the designated parameter to a `Reader` object. The `Reader` reads the data till end-of-file is reached. The driver does the necessary conversion from Java character format to the national character set in the database.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setNCharacterStream` which takes a length parameter.

Specified by:
  `setNCharacterStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - of the first parameter is 1, the second is 2, ...
  `value` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs; or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### setNClob

    public void setNClob(int parameterIndex,
                         NClob value)
                  throws SQLException

Sets the designated parameter to a `java.sql.NClob` object. The driver converts this to a SQL `NCLOB` value when it sends it to the database.

Specified by:
  `setNClob` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - of the first parameter is 1, the second is 2, ...
  `value` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs; or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### setNClob

    public void setNClob(int parameterIndex,
                         Reader reader,
                         long length)
                  throws SQLException

Sets the designated parameter to a `Reader` object. The reader must contain the number of characters specified by length otherwise a `SQLException` will be generated when the `PreparedStatement` is executed. This method differs from the `setCharacterStream (int, Reader, int)` method because it informs the driver that the parameter value should be sent to the server as a `NCLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGNVARCHAR` or a `NCLOB`

Specified by:
  `setNClob` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - index of the first parameter is 1, the second is 2, ...
  `reader` - An object that contains the data to set the parameter value to.
  `length` - the number of characters in the parameter data.
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the length specified is less than zero; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### setNClob

    public void setNClob(int parameterIndex,
                         Reader reader)
                  throws SQLException

Sets the designated parameter to a `Reader` object. This method differs from the `setCharacterStream (int, Reader)` method because it informs the driver that the parameter value should be sent to the server as a `NCLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGNVARCHAR` or a `NCLOB`

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setNClob` which takes a length parameter.

Specified by:
  `setNClob` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - index of the first parameter is 1, the second is 2, ...
  `reader` - An object that contains the data to set the parameter value to.
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### setSQLXML

    public void setSQLXML(int parameterIndex,
                          SQLXML xmlObject)
                   throws SQLException

Sets the designated parameter to the given `java.sql.SQLXML` object. The driver converts this to an SQL `XML` value when it sends it to the database.

Specified by:
  `setSQLXML` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - index of the first parameter is 1, the second is 2, ...
  `xmlObject` - a `SQLXML` object that maps an SQL `XML` value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs; this method is called on a closed `PreparedStatement` or the `java.xml.transform.Result`, `Writer` or `OutputStream` has not been closed for the `SQLXML` object
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### setObject

    public void setObject(int parameterIndex,
                          Object obj,
                          int targetSqlType,
                          int scaleOrLength)
                   throws SQLException

Sets the value of the designated parameter with the given object. The second argument must be an object type; for integral values, the `java.lang` equivalent objects should be used.
If the second argument is an `InputStream` then the stream must contain the number of bytes specified by scaleOrLength. If the second argument is a `Reader` then the reader must contain the number of characters specified by scaleOrLength. If these conditions are not true the driver will generate a `SQLException` when the prepared statement is executed.

The given Java object will be converted to the given targetSqlType before being sent to the database.
If the object has a custom mapping (is of a class implementing the interface `SQLData`), the JDBC driver should call the method `SQLData.writeSQL` to write it to the SQL data stream. If, on the other hand, the object is of a class implementing `Ref`, `Blob`, `Clob`, `NClob`, `Struct`, `java.net.URL`, or `Array`, the driver should pass it to the database as a value of the corresponding SQL type.

Note that this method may be used to pass database-specific abstract data types.

Specified by:
  `setObject` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `obj` - the object containing the input parameter value
  `targetSqlType` - the SQL type (as defined in java.sql.Types) to be sent to the database. The scale argument may further qualify this type.
  `scaleOrLength` - for `java.sql.Types.DECIMAL` or `java.sql.Types.NUMERIC types`, this is the number of digits after the decimal point. For Java Object types `InputStream` and `Reader`, this is the length of the data in the stream or reader. For all other types, this value will be ignored.
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs; this method is called on a closed `PreparedStatement` or if the Java Object specified by x is an InputStream or Reader object and the value of the scale parameter is less than zero
  `SQLFeatureNotSupportedException` - if `targetSqlType` is a `ARRAY`, `BLOB`, `CLOB`, `DATALINK`, `JAVA_OBJECT`, `NCHAR`, `NCLOB`, `NVARCHAR`, `LONGNVARCHAR`, `REF`, `ROWID`, `SQLXML` or `STRUCT` data type and the JDBC driver does not support this data type
See Also:
  `Types`

#### setObject

    public void setObject(int parameterIndex,
                          Object obj,
                          int targetSqlType)
                   throws SQLException

Sets the value of the designated parameter with the given object. This method is like the method `setObject` above, except that it assumes a scale of zero.

Specified by:
  `setObject` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `obj` - the object containing the input parameter value
  `targetSqlType` - the SQL type (as defined in java.sql.Types) to be sent to the database
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if `targetSqlType` is a `ARRAY`, `BLOB`, `CLOB`, `DATALINK`, `JAVA_OBJECT`, `NCHAR`, `NCLOB`, `NVARCHAR`, `LONGNVARCHAR`, `REF`, `ROWID`, `SQLXML` or `STRUCT` data type and the JDBC driver does not support this data type
See Also:
  `Types`

#### setObject

    public void setObject(int parameterIndex,
                          Object obj)
                   throws SQLException

Sets the value of the designated parameter using the given object. The second parameter must be of type `Object`; therefore, the `java.lang` equivalent objects should be used for built-in types.

The JDBC specification specifies a standard mapping from Java `Object` types to SQL types. The given argument will be converted to the corresponding SQL type before being sent to the database.

Note that this method may be used to pass datatabase- specific abstract data types, by using a driver-specific Java type.
If the object is of a class implementing the interface `SQLData`, the JDBC driver should call the method `SQLData.writeSQL` to write it to the SQL data stream. If, on the other hand, the object is of a class implementing `Ref`, `Blob`, `Clob`, `NClob`, `Struct`, `java.net.URL`, `RowId`, `SQLXML` or `Array`, the driver should pass it to the database as a value of the corresponding SQL type.
Note: Not all databases allow for a non-typed Null to be sent to the backend. For maximum portability, the `setNull` or the `setObject(int parameterIndex, Object x, int sqlType)` method should be used instead of `setObject(int parameterIndex, Object x)`.
Note: This method throws an exception if there is an ambiguity, for example, if the object is of a class implementing more than one of the interfaces named above.

Specified by:
  `setObject` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `obj` - the object containing the input parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs; this method is called on a closed `PreparedStatement` or the type of the given object is ambiguous

#### setAsciiStream

    public void setAsciiStream(int parameterIndex,
                               InputStream stream,
                               long length)
                        throws SQLException

Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large ASCII value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream`. Data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from ASCII to the database char format.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Specified by:
  `setAsciiStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `stream` - the Java input stream that contains the ASCII parameter value
  `length` - the number of bytes in the stream
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

#### setAsciiStream

    public void setAsciiStream(int parameterIndex,
                               InputStream stream)
                        throws SQLException

This function reads up the entire stream and stores it in memory since we need to know the length when sending it to the server use the corresponding method with a length parameter if memory is an issue
Sets the designated parameter to the given input stream. When a very large ASCII value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream`. Data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from ASCII to the database char format.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setAsciiStream` which takes a length parameter.

Specified by:
  `setAsciiStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `stream` - the Java input stream that contains the ASCII parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### setAsciiStream

    public void setAsciiStream(int parameterIndex,
                               InputStream stream,
                               int length)
                        throws SQLException

Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large ASCII value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream`. Data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from ASCII to the database char format.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Specified by:
  `setAsciiStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `stream` - the Java input stream that contains the ASCII parameter value
  `length` - the number of bytes in the stream
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

#### setBinaryStream

    public void setBinaryStream(int parameterIndex,
                                InputStream stream,
                                long length)
                         throws SQLException

Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large binary value is input to a `LONGVARBINARY` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Specified by:
  `setBinaryStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `stream` - the java input stream which contains the binary parameter value
  `length` - the number of bytes in the stream
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

#### setBinaryStream

    public void setBinaryStream(int parameterIndex,
                                InputStream stream)
                         throws SQLException

This function reads up the entire stream and stores it in memory since we need to know the length when sending it to the server
Sets the designated parameter to the given input stream. When a very large binary value is input to a `LONGVARBINARY` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setBinaryStream` which takes a length parameter.

Specified by:
  `setBinaryStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `stream` - the java input stream which contains the binary parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### setBinaryStream

    public void setBinaryStream(int parameterIndex,
                                InputStream stream,
                                int length)
                         throws SQLException

Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large binary value is input to a `LONGVARBINARY` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Specified by:
  `setBinaryStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `stream` - the java input stream which contains the binary parameter value
  `length` - the number of bytes in the stream
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

#### setBoolean

    public void setBoolean(int parameterIndex,
                           boolean value)
                    throws SQLException

Sets the designated parameter to the given Java `boolean` value. The driver converts this to an SQL `BIT` or `BOOLEAN` value when it sends it to the database.

Specified by:
  `setBoolean` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `value` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

#### setByte

    public void setByte(int parameterIndex,
                        byte bit)
                 throws SQLException

Sets the designated parameter to the given Java `byte` value. The driver converts this to an SQL `TINYINT` value when it sends it to the database.

Specified by:
  `setByte` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `bit` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

#### setShort

    public void setShort(int parameterIndex,
                         short value)
                  throws SQLException

Sets the designated parameter to the given Java `short` value. The driver converts this to an SQL `SMALLINT` value when it sends it to the database.

Specified by:
  `setShort` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `value` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

#### setString

    public void setString(int parameterIndex,
                          String str)
                   throws SQLException

Set string parameter.

Specified by:
  `setString` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `str` - String
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

#### setBytes

    public void setBytes(int parameterIndex,
                         byte[] bytes)
                  throws SQLException

Sets the designated parameter to the given Java array of bytes. The driver converts this to an SQL `VARBINARY` or `LONGVARBINARY` (depending on the argument's size relative to the driver's limits on `VARBINARY` values) when it sends it to the database.

Specified by:
  `setBytes` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `bytes` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

#### setUnicodeStream

    public void setUnicodeStream(int parameterIndex,
                                 InputStream x,
                                 int length)
                          throws SQLException

Deprecated.
Sets the designated parameter to the given input stream, which will have the specified number of bytes.
When a very large Unicode value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from Unicode to the database char format.
The byte format of the Unicode stream must be a Java UTF-8, as defined in the Java Virtual Machine Specification.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Specified by:
  `setUnicodeStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - a `java.io.InputStream` object that contains the Unicode parameter value
  `length` - the number of bytes in the stream
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### setInt

    public void setInt(int column,
                       int value)
                throws SQLException

Specified by:
  `setInt` in interface `PreparedStatement`
Throws:
  `SQLException`

#### setLong

    public void setLong(int parameterIndex,
                        long value)
                 throws SQLException

Sets the designated parameter to the given Java `long` value. The driver converts this to an SQL `BIGINT` value when it sends it to the database.

Specified by:
  `setLong` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `value` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

#### setFloat

    public void setFloat(int parameterIndex,
                         float value)
                  throws SQLException

Sets the designated parameter to the given Java `float` value. The driver converts this to an SQL `REAL` value when it sends it to the database.

Specified by:
  `setFloat` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `value` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

#### setDouble

    public void setDouble(int parameterIndex,
                          double value)
                   throws SQLException

Sets the designated parameter to the given Java `double` value. The driver converts this to an SQL `DOUBLE` value when it sends it to the database.

Specified by:
  `setDouble` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `value` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

#### setBigDecimal

    public void setBigDecimal(int parameterIndex,
                              BigDecimal bigDecimal)
                       throws SQLException

Sets the designated parameter to the given `java.math.BigDecimal` value. The driver converts this to an SQL `NUMERIC` value when it sends it to the database.

Specified by:
  `setBigDecimal` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `bigDecimal` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`